use RRDs;
#use Chart::StackedBars;
use GD::Graph::bars;

$RRDpath = "O:\\data\\rrd\\data\\nbii\\";


@rrdl = ("wzhrq1","wzhrq2","wgdrq3","wgdrq4");
#@rrdl = ("wzhrq1","wzhrq2","wgdrq3","wgdrq4","wgdrq5","wgdrq6","wmerq1","wmerq2","wmerq3","tfrrq1","tfrrq2", "tmerq1", "tmerq2", "tzhrq1","tzhrq2", "tsgrq1", "tsgrq2");
#@rrdl = ("wzhrq1","wzhrq2","wgdrq3","wgdrq4");

$nbdist = 10;
$maxval = 100;
$minval = 0;
$start = "-1d";
$end = "+1h";

undef @data;
undef %mean;
undef @legend;

foreach $rrd (@rrdl) {
	#my (@m) = RRDs::stats $RRDpath . $rrd . ".rrd", "mean:300:AVERAGE","--start=$start","--end=$end";
	my ($step,$start,$end,$res,$names) = RRDs::stats $RRDpath . $rrd . ".rrd", "mean:300:AVERAGE","--start=$start","--end=$end";
	$ERROR = RRDs::error;
	print "ERROR: $ERROR\n" if $ERROR;
	print "mean $rrd ($step,$start,$end,$res,$names): @$res[0]\n";
	$mean{$rrd} = @$res[0];
}

$j = 0;
foreach $rrd (sort {$mean{$b}<=>$mean{$a}} keys %mean) {
#for ($j = 0; $j < @rrdl; $j++) {
	#$rrd = @rrdl[$j];
	#@legend[$j] = $rrd;
	$data[0][$j] = $rrd;

	my ($ste, $sta, $en, $before, $after, $res) = RRDs::stats $RRDpath . $rrd . ".rrd", "dist:$minval:$maxval:ds0:$nbdist:300:AVERAGE","--start=$start","--end=$end";
	$ERROR = RRDs::error;
	print "ERROR: $ERROR\n" if $ERROR;
	print "$rrd : step($ste) start ($sta) end($en) before($before), after($after), values : ";

	for ($i=0; $i < $nbdist; $i++) {
		$data[$i+1][$j] = (@$res[$i] * 100);
		print " " . @$res[$i];
	}
	print "\n";
	$j++;
}

$my_graph = new GD::Graph::bars();
$my_graph->set(
	x_label => 'router name',
	y_label => '% cpu',
	title => 'CPU load distribution',
	y_tick_number => 8,
	cumulate => 1,
#	y_label_skip => 2,
	overwrite => 1,
	bar_spacing => 4,
#	shadow_depth => 4,
);

#$g = Chart::StackedBars->new(600,300);
#$g->clear_data;
#$g->set ('max_val' => 100 );
#$g->set ('gif_border' => 5 );
#$g->set ('graph_border' => 8 );

$int = ($maxval-$minval) / $nbdist;
for ( $i = 0; $i < $nbdist; $i ++ ) {
	$j = sprintf ("%d-%d %%", $minval + ($i * $int), $minval + (($i+1)*$int));
	#$data[$i][0] = $j;
	#push @labels, $j;
	print "$j\n";
}

#@data = (
#    ["1st","2nd","3rd","4th","5th","6th","7th", "8th", "9th"],
#    [    5,   12,   24,   33,   19,    8,    6,    15,    21],
#    [    1,    2,    5,    6,    3,  1.5,    1,     3,     4]
#);

$my_graph->plot(\@data);
open(OUT, ">demo2.bars.png") or
		die "Cannot open for write: $!";
binmode OUT;
print OUT $my_graph->gd->png();
close OUT;

#$g->set ('legend_labels' => \@labels);
#$g->add_dataset (@legend);
#for ($i=0; $i < $nbdist; $i++) {
#	$aref = $data[$i];
#	$g->add_dataset (@$aref);
#}

#$g->set('colors' =>{
#					'dataset0' => [245,245,245],
#					'dataset1' => [174,233,195],
#					'dataset2' => [124,208,166],
#					'dataset3' => [41,168,137],
#					'dataset4' => [23,133,92],
#					'dataset5' => [255,200,200],
#					'dataset6' => [255,170,170],
#					'dataset7' => [255,140,140],
#					'dataset8' => [255,100,100],
#					'dataset9' => [255,0,0]});

#$g->set ('grid_lines' => 'true');		# or undef
#$g->set ('title' => 'CPU load distribution');
#$g->gif ("demo2.bars.gif", \@data);
#$g->gif ("demo2.bars.gif");

exit(0);



